// **********************************************************************
//
// Copyright (c) 2003-2018 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.7.1
//
// <auto-generated>
//
// Generated from file `Session.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package Glacier2;

/**
 * An object for managing the set of object identity constraints on a
 * {@link Session}.
 *
 * @see Session
 * @see SessionControl
 *
 **/
public interface IdentitySetPrx extends Ice.ObjectPrx
{
    /**
     * Add a sequence of Ice identities to this set of constraints. Order is
     * not preserved and duplicates are implicitly removed.
     *
     * @param additions The sequence of Ice identities to be added.
     *
     **/
    public void add(Ice.Identity[] additions);

    /**
     * Add a sequence of Ice identities to this set of constraints. Order is
     * not preserved and duplicates are implicitly removed.
     *
     * @param additions The sequence of Ice identities to be added.
     *
     * @param context The Context map to send with the invocation.
     **/
    public void add(Ice.Identity[] additions, java.util.Map<String, String> context);

    /**
     * Add a sequence of Ice identities to this set of constraints. Order is
     * not preserved and duplicates are implicitly removed.
     *
     * @param additions The sequence of Ice identities to be added.
     *
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_add(Ice.Identity[] additions);

    /**
     * Add a sequence of Ice identities to this set of constraints. Order is
     * not preserved and duplicates are implicitly removed.
     *
     * @param additions The sequence of Ice identities to be added.
     *
     * @param context The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_add(Ice.Identity[] additions, java.util.Map<String, String> context);

    /**
     * Add a sequence of Ice identities to this set of constraints. Order is
     * not preserved and duplicates are implicitly removed.
     *
     * @param additions The sequence of Ice identities to be added.
     *
     * @param cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_add(Ice.Identity[] additions, Ice.Callback cb);

    /**
     * Add a sequence of Ice identities to this set of constraints. Order is
     * not preserved and duplicates are implicitly removed.
     *
     * @param additions The sequence of Ice identities to be added.
     *
     * @param context The Context map to send with the invocation.
     * @param cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_add(Ice.Identity[] additions, java.util.Map<String, String> context, Ice.Callback cb);

    /**
     * Add a sequence of Ice identities to this set of constraints. Order is
     * not preserved and duplicates are implicitly removed.
     *
     * @param additions The sequence of Ice identities to be added.
     *
     * @param cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_add(Ice.Identity[] additions, Callback_IdentitySet_add cb);

    /**
     * Add a sequence of Ice identities to this set of constraints. Order is
     * not preserved and duplicates are implicitly removed.
     *
     * @param additions The sequence of Ice identities to be added.
     *
     * @param context The Context map to send with the invocation.
     * @param cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_add(Ice.Identity[] additions, java.util.Map<String, String> context, Callback_IdentitySet_add cb);

    /**
     * Add a sequence of Ice identities to this set of constraints. Order is
     * not preserved and duplicates are implicitly removed.
     *
     * @param additions The sequence of Ice identities to be added.
     *
     * @param responseCb The lambda response callback.
     * @param exceptionCb The lambda exception callback.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_add(Ice.Identity[] additions,
                                     IceInternal.Functional_VoidCallback responseCb,
                                     IceInternal.Functional_GenericCallback1<Ice.Exception> exceptionCb);

    /**
     * Add a sequence of Ice identities to this set of constraints. Order is
     * not preserved and duplicates are implicitly removed.
     *
     * @param additions The sequence of Ice identities to be added.
     *
     * @param responseCb The lambda response callback.
     * @param exceptionCb The lambda exception callback.
     * @param sentCb The lambda sent callback.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_add(Ice.Identity[] additions,
                                     IceInternal.Functional_VoidCallback responseCb,
                                     IceInternal.Functional_GenericCallback1<Ice.Exception> exceptionCb,
                                     IceInternal.Functional_BoolCallback sentCb);

    /**
     * Add a sequence of Ice identities to this set of constraints. Order is
     * not preserved and duplicates are implicitly removed.
     *
     * @param additions The sequence of Ice identities to be added.
     *
     * @param context The Context map to send with the invocation.
     * @param responseCb The lambda response callback.
     * @param exceptionCb The lambda exception callback.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_add(Ice.Identity[] additions,
                                     java.util.Map<String, String> context,
                                     IceInternal.Functional_VoidCallback responseCb,
                                     IceInternal.Functional_GenericCallback1<Ice.Exception> exceptionCb);

    /**
     * Add a sequence of Ice identities to this set of constraints. Order is
     * not preserved and duplicates are implicitly removed.
     *
     * @param additions The sequence of Ice identities to be added.
     *
     * @param context The Context map to send with the invocation.
     * @param responseCb The lambda response callback.
     * @param exceptionCb The lambda exception callback.
     * @param sentCb The lambda sent callback.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_add(Ice.Identity[] additions,
                                     java.util.Map<String, String> context,
                                     IceInternal.Functional_VoidCallback responseCb,
                                     IceInternal.Functional_GenericCallback1<Ice.Exception> exceptionCb,
                                     IceInternal.Functional_BoolCallback sentCb);

    /**
     * Add a sequence of Ice identities to this set of constraints. Order is
     * not preserved and duplicates are implicitly removed.
     *
     * @param result The asynchronous result object.
     **/
    public void end_add(Ice.AsyncResult result);

    /**
     * Remove a sequence of identities from this set of constraints. No
     * errors are returned if an entry is not found.
     *
     * @param deletions The sequence of Ice identities to be removed.
     *
     **/
    public void remove(Ice.Identity[] deletions);

    /**
     * Remove a sequence of identities from this set of constraints. No
     * errors are returned if an entry is not found.
     *
     * @param deletions The sequence of Ice identities to be removed.
     *
     * @param context The Context map to send with the invocation.
     **/
    public void remove(Ice.Identity[] deletions, java.util.Map<String, String> context);

    /**
     * Remove a sequence of identities from this set of constraints. No
     * errors are returned if an entry is not found.
     *
     * @param deletions The sequence of Ice identities to be removed.
     *
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_remove(Ice.Identity[] deletions);

    /**
     * Remove a sequence of identities from this set of constraints. No
     * errors are returned if an entry is not found.
     *
     * @param deletions The sequence of Ice identities to be removed.
     *
     * @param context The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_remove(Ice.Identity[] deletions, java.util.Map<String, String> context);

    /**
     * Remove a sequence of identities from this set of constraints. No
     * errors are returned if an entry is not found.
     *
     * @param deletions The sequence of Ice identities to be removed.
     *
     * @param cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_remove(Ice.Identity[] deletions, Ice.Callback cb);

    /**
     * Remove a sequence of identities from this set of constraints. No
     * errors are returned if an entry is not found.
     *
     * @param deletions The sequence of Ice identities to be removed.
     *
     * @param context The Context map to send with the invocation.
     * @param cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_remove(Ice.Identity[] deletions, java.util.Map<String, String> context, Ice.Callback cb);

    /**
     * Remove a sequence of identities from this set of constraints. No
     * errors are returned if an entry is not found.
     *
     * @param deletions The sequence of Ice identities to be removed.
     *
     * @param cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_remove(Ice.Identity[] deletions, Callback_IdentitySet_remove cb);

    /**
     * Remove a sequence of identities from this set of constraints. No
     * errors are returned if an entry is not found.
     *
     * @param deletions The sequence of Ice identities to be removed.
     *
     * @param context The Context map to send with the invocation.
     * @param cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_remove(Ice.Identity[] deletions, java.util.Map<String, String> context, Callback_IdentitySet_remove cb);

    /**
     * Remove a sequence of identities from this set of constraints. No
     * errors are returned if an entry is not found.
     *
     * @param deletions The sequence of Ice identities to be removed.
     *
     * @param responseCb The lambda response callback.
     * @param exceptionCb The lambda exception callback.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_remove(Ice.Identity[] deletions,
                                        IceInternal.Functional_VoidCallback responseCb,
                                        IceInternal.Functional_GenericCallback1<Ice.Exception> exceptionCb);

    /**
     * Remove a sequence of identities from this set of constraints. No
     * errors are returned if an entry is not found.
     *
     * @param deletions The sequence of Ice identities to be removed.
     *
     * @param responseCb The lambda response callback.
     * @param exceptionCb The lambda exception callback.
     * @param sentCb The lambda sent callback.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_remove(Ice.Identity[] deletions,
                                        IceInternal.Functional_VoidCallback responseCb,
                                        IceInternal.Functional_GenericCallback1<Ice.Exception> exceptionCb,
                                        IceInternal.Functional_BoolCallback sentCb);

    /**
     * Remove a sequence of identities from this set of constraints. No
     * errors are returned if an entry is not found.
     *
     * @param deletions The sequence of Ice identities to be removed.
     *
     * @param context The Context map to send with the invocation.
     * @param responseCb The lambda response callback.
     * @param exceptionCb The lambda exception callback.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_remove(Ice.Identity[] deletions,
                                        java.util.Map<String, String> context,
                                        IceInternal.Functional_VoidCallback responseCb,
                                        IceInternal.Functional_GenericCallback1<Ice.Exception> exceptionCb);

    /**
     * Remove a sequence of identities from this set of constraints. No
     * errors are returned if an entry is not found.
     *
     * @param deletions The sequence of Ice identities to be removed.
     *
     * @param context The Context map to send with the invocation.
     * @param responseCb The lambda response callback.
     * @param exceptionCb The lambda exception callback.
     * @param sentCb The lambda sent callback.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_remove(Ice.Identity[] deletions,
                                        java.util.Map<String, String> context,
                                        IceInternal.Functional_VoidCallback responseCb,
                                        IceInternal.Functional_GenericCallback1<Ice.Exception> exceptionCb,
                                        IceInternal.Functional_BoolCallback sentCb);

    /**
     * Remove a sequence of identities from this set of constraints. No
     * errors are returned if an entry is not found.
     *
     * @param result The asynchronous result object.
     **/
    public void end_remove(Ice.AsyncResult result);

    /**
     * Returns a sequence of identities describing the constraints in this
     * set.
     *
     * @return The sequence of Ice identities for this set.
     *
     **/
    public Ice.Identity[] get();

    /**
     * Returns a sequence of identities describing the constraints in this
     * set.
     *
     * @param context The Context map to send with the invocation.
     * @return The sequence of Ice identities for this set.
     *
     **/
    public Ice.Identity[] get(java.util.Map<String, String> context);

    /**
     * Returns a sequence of identities describing the constraints in this
     * set.
     *
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_get();

    /**
     * Returns a sequence of identities describing the constraints in this
     * set.
     *
     * @param context The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_get(java.util.Map<String, String> context);

    /**
     * Returns a sequence of identities describing the constraints in this
     * set.
     *
     * @param cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_get(Ice.Callback cb);

    /**
     * Returns a sequence of identities describing the constraints in this
     * set.
     *
     * @param context The Context map to send with the invocation.
     * @param cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_get(java.util.Map<String, String> context, Ice.Callback cb);

    /**
     * Returns a sequence of identities describing the constraints in this
     * set.
     *
     * @param cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_get(Callback_IdentitySet_get cb);

    /**
     * Returns a sequence of identities describing the constraints in this
     * set.
     *
     * @param context The Context map to send with the invocation.
     * @param cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_get(java.util.Map<String, String> context, Callback_IdentitySet_get cb);

    /**
     * Returns a sequence of identities describing the constraints in this
     * set.
     *
     * @param responseCb The lambda response callback.
     * @param exceptionCb The lambda exception callback.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_get(IceInternal.Functional_GenericCallback1<Ice.Identity[]> responseCb,
                                     IceInternal.Functional_GenericCallback1<Ice.Exception> exceptionCb);

    /**
     * Returns a sequence of identities describing the constraints in this
     * set.
     *
     * @param responseCb The lambda response callback.
     * @param exceptionCb The lambda exception callback.
     * @param sentCb The lambda sent callback.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_get(IceInternal.Functional_GenericCallback1<Ice.Identity[]> responseCb,
                                     IceInternal.Functional_GenericCallback1<Ice.Exception> exceptionCb,
                                     IceInternal.Functional_BoolCallback sentCb);

    /**
     * Returns a sequence of identities describing the constraints in this
     * set.
     *
     * @param context The Context map to send with the invocation.
     * @param responseCb The lambda response callback.
     * @param exceptionCb The lambda exception callback.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_get(java.util.Map<String, String> context,
                                     IceInternal.Functional_GenericCallback1<Ice.Identity[]> responseCb,
                                     IceInternal.Functional_GenericCallback1<Ice.Exception> exceptionCb);

    /**
     * Returns a sequence of identities describing the constraints in this
     * set.
     *
     * @param context The Context map to send with the invocation.
     * @param responseCb The lambda response callback.
     * @param exceptionCb The lambda exception callback.
     * @param sentCb The lambda sent callback.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_get(java.util.Map<String, String> context,
                                     IceInternal.Functional_GenericCallback1<Ice.Identity[]> responseCb,
                                     IceInternal.Functional_GenericCallback1<Ice.Exception> exceptionCb,
                                     IceInternal.Functional_BoolCallback sentCb);

    /**
     * Returns a sequence of identities describing the constraints in this
     * set.
     *
     * @param result The asynchronous result object.
     * @return The sequence of Ice identities for this set.
     *
     **/
    public Ice.Identity[] end_get(Ice.AsyncResult result);
}
